.\" This manpage has been automatically generated by docbook2man 
.\" from a DocBook document.  This tool can be found at:
.\" <http://shell.ipoline.com/~elmert/hacks/docbook2X/> 
.\" Please send any bug reports, improvements, comments, patches, 
.\" etc. to Steve Cheng <steve@ggi-project.org>.
.\" Patched 1999-08-03 by Thomas Lockhart <lockhart@alumni.caltech.edu>
.\" for the PostgreSQL RDBMS project (http://postgresql.org).
.TH "DROP_SEQUENCE" "l" "15 August 1999" "SQL - Language Statements" ""
.SH NAME
DROP SEQUENCE \- Removes an existing sequence
.SH SYNOPSIS
.sp
.nf
DROP SEQUENCE \fIname\fR [, ...]
  
.sp
.fi
.SS "INPUTS"
.PP
.TP
\fB\fIname\fB\fR
The name of a sequence.
.PP
.SS "OUTPUTS"
.PP
.TP
\fBDROP\fR
The message returned if the sequence is successfully dropped.
.TP
\fBWARN: Relation "\fIname\fB" does not exist.\fR
This message occurs if the specified sequence does not exist.
.PP
.SH "DESCRIPTION"
.PP
\fBDROP SEQUENCE\fR removes sequence number generators from the
data base. With the current implementation of sequences as
special tables it works just like the \fBDROP TABLE\fR
statement.
.SS "NOTES"
.PP
The \fBDROP SEQUENCE\fR statement is a
Postgres
language extension.
.PP
Refer to the \fBCREATE SEQUENCE\fR statement for
information on how to create a sequence.
.SH "USAGE"
.PP
To remove sequence serial from database:
.sp
.nf
DROP SEQUENCE serial;
   
.sp
.fi
.SH "COMPATIBILITY"
.SS "SQL92"
.PP
There is no \fBDROP SEQUENCE\fR in SQL92.
