.\" This manpage has been automatically generated by docbook2man 
.\" from a DocBook document.  This tool can be found at:
.\" <http://shell.ipoline.com/~elmert/hacks/docbook2X/> 
.\" Please send any bug reports, improvements, comments, patches, 
.\" etc. to Steve Cheng <steve@ggi-project.org>.
.\" Patched 1999-08-03 by Thomas Lockhart <lockhart@alumni.caltech.edu>
.\" for the PostgreSQL RDBMS project (http://postgresql.org).
.TH "SELECT_INTO" "l" "15 August 1999" "SQL - Language Statements" ""
.SH NAME
SELECT INTO \- Create a new table from an existing table or view
.SH SYNOPSIS
.sp
.nf
SELECT [ ALL | DISTINCT ] \fIexpression\fR [ AS \fIname\fR ] [, ...]
    INTO [TEMP] [ TABLE ] \fInew_table\fR ]
    [ FROM \fItable\fR [\fIalias\fR] [, ...] ]
    [ WHERE \fIcondition\fR ]
    [ GROUP BY \fIcolumn\fR [, ...] ]
    [ HAVING \fIcondition\fR [, ...] ]
    [ { UNION [ALL] | INTERSECT | EXCEPT } \fIselect\fR]
    [ ORDER BY \fIcolumn\fR [ ASC | DESC ] [, ...] ]
    [ FOR UPDATE [OF class_name...]]
    [ LIMIT count [OFFSET|, count]]
  
.sp
.fi
.SS "INPUTS"
.PP
All input fields are described in detail for
\fBselect\fR(l).
.SS "OUTPUTS"
.PP
All output fields are described in detail for
\fBselect\fR(l).
.SH "DESCRIPTION"
.PP
\fBSELECT INTO\fR creates a new table from the results
of a query. Typically, this
query draws data from an existing table, but any SQL query is allowed.
.sp
.RS
.B "Note:"
\fBcreate_table_as\fR(l)
is functionally equivalent to the \fBSELECT INTO\fR command.
.RE
.sp
