.\" This manpage has been automatically generated by docbook2man 
.\" from a DocBook document.  This tool can be found at:
.\" <http://shell.ipoline.com/~elmert/hacks/docbook2X/> 
.\" Please send any bug reports, improvements, comments, patches, 
.\" etc. to Steve Cheng <steve@ggi-project.org>.
.\" Patched 1999-08-03 by Thomas Lockhart <lockhart@alumni.caltech.edu>
.\" for the PostgreSQL RDBMS project (http://postgresql.org).
.TH "SHOW" "l" "15 August 1999" "SQL - Language Statements" ""
.SH NAME
SHOW \- Shows run-time parameters for session
.SH SYNOPSIS
.sp
.nf
SHOW \fIkeyword\fR
  
.sp
.fi
.SS "INPUTS"
.PP
.TP
\fB\fIkeyword\fB\fR
Refer to \fBSET\fR for more information on available
arguments.
.PP
.SS "OUTPUTS"
.PP
.TP
\fBNOTICE: \fIvariable\fB is \fIvalue\fB\fR
Message returned if successful.
.TP
\fBNOTICE: Unrecognized variable \fIvalue\fB\fR
Message returned if value does not exist.
.TP
\fBNOTICE: Time zone is unknown\fR
If the \fBTZ\fR or \fBPGTZ\fR environment
variable is not set.
.PP
.SH "DESCRIPTION"
.PP
\fBSHOW\fR will display the current
configuration parameters for
variable during a session.
.PP
The session can be configured using \fBSET\fR statement,
and values
can be restored to the defaults using \fBRESET\fR statement.
Parameters and values are case-insensitive.
.SS "NOTES"
.PP
The \fBSHOW\fR is a Postgres
language extension.
.PP
Refer to \fBSET\fR/\fBRESET\fR 
to set/reset variable values.
See also \fBSET TIME ZONE\fR.
.SH "USAGE"
.PP
Show the current DateStyle setting:
.sp
.nf
SHOW DateStyle;
NOTICE:DateStyle is Postgres with US (NonEuropean) conventions
   
.sp
.fi
.PP
Show the current genetic optimizer (geqo) setting:
.sp
.nf
SHOW GEQO;
NOTICE:GEQO is ON
   
.sp
.fi
.SH "COMPATIBILITY"
.SS "SQL92"
.PP
There is no \fBSHOW\fR defined in SQL92.
